package webdb51;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectStreamField;
import java.io.Serializable;

/**
 * hɎQێNX
 */
public class CampMember implements Serializable
{
    /**
     * Bnullɂ͂Ȃ܂B
     * Member͒񉻂łȂNXłB
     */
    private transient Member member;

    /**
     * RXgN^sǂtOB
     * 񉻑ΏۊOł邱Ƃ𖾎IɎ transient ǉB
     */
    private transient boolean _didConstructor = false;

    /**
     * @serialField id int IDԍB̒l蓾܂B
     * @serialField name String ̖OB̒lnullɂȂ邱Ƃ܂B
     */
    private static final ObjectStreamField[] serialPersistentFields = {
        new ObjectStreamField("id", int.class),
        new ObjectStreamField("name", String.class)
    };

    /**
     * w肳ꂽԍƖOCampMemberIuWFNg\z܂B
     * @param id IDԍ
     * @param name ̖O
     */
    public CampMember(int id, String name)
    {
        member = new Member(id, name);
        _didConstructor = true;
    }

    /**
     * MemberIuWFNgƂĕԂ܂B
     * @return i[MemberIuWFNg
     */
    public Member getMember()
    {
        return member;
    }

    /**
     * RXgN^sꂽƂtOԂ܂B
     * 񉻂IuWFNg𕜌ꍇ̓RXgN^͌Ă΂܂B
     * @return RXgN^Ă΂ꂽꍇ true
     */
    public boolean didConstructor()
    {
        return _didConstructor;
    }

    /**
     * 񉻂tB[ho̓Xg[ɏo܂B
     * otB[hserialPersistentFieldsɋLqꂽA^ōs܂B
     * @throws IOException IuWFNg̏oɎsꍇ
     * @serialData serialPersistentFields̃tB[ĥݏo܂B
     */
    private void writeObject(ObjectOutputStream s) throws IOException
    {
	    ObjectOutputStream.PutField fields = s.putFields();
	    fields.put("id", member.getId());
	    fields.put("name", member.getName());

        s.writeFields();
    }

    /**
     * 񉻂ꂽtB[h̓Xg[ǂݍ݂܂B
     * ǂݍރtB[hserialPersistentFieldsɋLqꂽA^ōs܂B
     * @throws IOException IuWFNg̓ǂݍ݂Ɏsꍇ
     * @serialData serialPersistentFields̃tB[ĥݓǂݍ܂܂B
     */
    private void readObject(ObjectInputStream s) throws IOException
    {
	    ObjectInputStream.GetField fields = null;
        try
        {
            fields = s.readFields();
        }
        catch (ClassNotFoundException ex)
        {
            throw new IOException(ex);
        }

        int id = (int) fields.get("id", 0);
        String name = (String) fields.get("name", null);

        member = new Member(id, name);
    }

    /**
     * @deprecated 1.2ȍ~ł{@link #hoge()}gpĂB
     * index͑SgĂȂ߁AȂ̃\bhɈڍsĂB
     */
     @Deprecated
     public void hoge(int index)
     {
     }

    /**
     * 񐄏\bh̑փ\bh̃Tv
     * @since 1.2
     */
     public void hoge()
     {
     }
}
