package com.javareading.taglet;

import com.sun.javadoc.Tag;
import com.sun.tools.doclets.Taglet;
import java.util.Map;

/**
 * O^ObgNX
 */
public class RequireTaglet implements Taglet
{
    /**
     * ^Obgo^܂B
     * @param map ^ÕCX^Xi[MapIuWFNg
     */
    public static void register(Map map)
    {
        RequireTaglet taglet = new RequireTaglet();
        Taglet t = (Taglet) map.get(taglet.getName());
        if(t != null)
        {
            map.remove(taglet.getName());
        }
        map.put(taglet.getName(), taglet);
    }

    /**
     * ̃JX^^O̖OԂ܂B
     * "@" + ̃\bh̖߂l̒l^O̖OƂȂ܂B
     * <P>
     * ) &#x40;require {@code text != null}
     * @return ^Obg̖O
     */
    public String getName()
    {
        return "require";
    }

    /**
     * ̃^ObgtB[hhLe[VŎgpĂꍇAtrue Ԃ܂B
     * @return false
     */
    public boolean inField()
    {
        return false;
    }

    /**
     * ̃^ObgRXgN^hLe[VŎgpĂꍇAtrue Ԃ܂B
     * @return true
     */
    public boolean inConstructor()
    {
        return true;
    }

    /**
     * ̃^Obg\bhLe[VŎgpĂꍇAtrue Ԃ܂B
     * @return true
     */
    public boolean inMethod()
    {
        return true;
    }

    /**
     * ̃^ObgTvhLe[VŎgpĂꍇAtrue Ԃ܂BCC^OɂĂ false ݒ肳܂B
     * @return false
     */
    public boolean inOverview()
    {
        return false;
    }

    /**
     * ̃^ObgpbP[WhLe[VŎgpĂꍇAtrue Ԃ܂B
     * @return false
     */
    public boolean inPackage()
    {
        return false;
    }

    /**
     * ̃^Obg^CvhLe[V (NX܂̓C^tF[X) ŎgpĂꍇAtrue Ԃ܂B
     * @return false
     */
    public boolean inType()
    {
        return false;
    }

    /**
     * ̃^ObgCC^Ołꍇ trueAłȂꍇ false Ԃ܂B
     * @return false
     */
    public boolean isInlineTag()
    {
        return false;
    }
    
    /**
     * ̃JX^^Õ^O\󂯎AƂĂ̕\ԂAꂽy[Wɏo͂܂B
     * @param tag ̃JX^^Õ^O\
     * @return ̃^O̕ƂĂ̕\
     */
    public String toString(Tag tag)
    {
        StringBuilder buf = new StringBuilder();
        buf.append("\n<DT><B>O:</B>");
        buf.append("<DD>- ");
        buf.append(tag.text());
        buf.append("</DD>\n");
        return buf.toString();
    }

    /**
     * ̃JX^^Õ^O\̔z󂯎AƂĂ̕\ԂAꂽy[Wɏo͂܂B
     * @param tags ̃JX^^O\^O̔z
     * @return ̃^O̕ƂĂ̕\
     */
    public String toString(Tag[] tags)
    {
        if (tags.length == 0) {
            return null;
        }

        StringBuilder buf = new StringBuilder();
        buf.append("\n<DT><B>O:</B>");
        for(Tag tag : tags)
        {
            buf.append("<DD>- ");
            buf.append(tag.text());
            buf.append("</DD>\n");
        }
        return buf.toString();
    }
}
